#include <reg52.h>       /* special function register declarations   */
#include <absacc.h>      /* for the intended 8051 derivative         */
#include <stdio.h>       /* prototype declarations for I/O functions */

                             /*     dp  g   f   e   d   c   b   a   */
unsigned char tab[]={ 0x3f,  /* 0:  0   0   1   1   1   1   1   1   */
                      0x06,  /* 1:  0   0   0   0   0   1   1   0   */
                      0x5b,  /* 2:  0   1   0   1   1   0   1   1   */
                      0x4f,  /* 3:  0   1   0   0   1   1   1   1   */
                      0x66,  /* 4:  0   1   1   0   0   1   1   0   */
                      0x6d,  /* 5:  0   1   1   0   1   1   0   1   */
                      0x7d,  /* 6:  0   1   1   1   1   1   0   1   */
                      0x27,  /* 7:  0   0   1   0   0   1   1   1   */
                      0x7f,  /* 8:  0   1   1   1   1   1   1   1   */
                      0x6f,  /* 9:  0   1   1   0   1   1   1   1   */
                      0x77,  /* a:  0   1   1   1   0   1   1   1   */
                      0x7c,  /* b:  0   1   1   1   1   1   0   0   */
                      0x39,  /* c:  0   0   1   1   1   0   0   1   */
                      0x5e,  /* d:  0   1   0   1   1   1   1   0   */
                      0x79,  /* e:  0   1   1   1   1   0   0   1   */
                      0x71,  /* f:  0   1   1   1   0   0   0   1   */
                      0x00,  /*  :  0   0   0   0   0   0   0   0   */
                      0x40   /* -:  0   1   0   0   0   0   0   0   */
                    };

unsigned char ScanPos = 0;
unsigned char dis[6];
unsigned char Dig[2] = {
  0x01, 0x02
};

unsigned char x, y;

unsigned char KEY;

unsigned char RdData;

unsigned char timer=0;

sbit ADCS = P1^4;
sbit ADCK = P1^7;
sbit ADDO = P1^5;
sbit ADDI = P1^6;

void main (void)  
{
  TMOD |= 0x01;   
  TH0 = 0xf7;
  TR0 = 1; 
  
  IE |= 0x82;

  while (1)
  {
    ADCK = 0;
    ADCS = 0;
    ADDI = 1;
    ADCK = 1;       // clk 1
    ADCK = 0;
    ADDI = 1;
    ADCK = 1;       // clk 2
    ADCK = 0;
    if(KEY != 0)
      ADDI = 1;
    else
      ADDI = 0;
    ADCK = 1;       // clk 3
    ADCK = 0;
    
    for(x = 0; x < 8; x ++)
    {
      ADCK = 1;       // clk 4
      ADCK = 0; 
      RdData <<= 1;
      if(ADDO != 0) RdData |= 0x01;
    }
    
    ADCS = 1;
    
    dis[1] = RdData&0x0f;
    dis[0] = RdData>>4;
  }                              
}

void T0IntSer(void) interrupt 1
{
  TH0=0xf7;
  
  XBYTE[0x8060] = 0x00;
  XBYTE[0x8061] = Dig[ScanPos];
  XBYTE[0x8060] = tab[dis[ScanPos]];
  x = XBYTE[0x8060];
  x <<= ScanPos*4;
  KEY &= ~(0x0f<<ScanPos*4);
  KEY |= x;
  ScanPos = (ScanPos+1)&0x01;
  
  timer++;
}
